<?xml version="1.0" encoding="utf-8" ?>
<ContentPage xmlns="http://schemas.microsoft.com/dotnet/2021/maui"
             xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
             x:Class="KieselsteinErp.Terminal.Views.SettingsPage"
             xmlns:toolkit="http://schemas.microsoft.com/dotnet/2022/maui/toolkit"
             xmlns:viewmodel="clr-namespace:KieselsteinErp.Terminal.ViewModels"
             xmlns:controls="clr-namespace:KieselsteinErp.Terminal.Controls"
             x:DataType="viewmodel:SettingsPageViewModel"
             xmlns:m="clr-namespace:UraniumUI.Icons.MaterialIcons;assembly=UraniumUI.Icons.MaterialIcons"
             xmlns:localization="clr-namespace:LocalizationResourceManager.Maui;assembly=LocalizationResourceManager.Maui">
  <ContentPage.Resources>
    <ResourceDictionary>
      <toolkit:InvertedBoolConverter x:Key="InvertedBoolConverter" />
    </ResourceDictionary>
  </ContentPage.Resources>

  <Grid RowDefinitions="Auto,*" >
    <Border Style="{StaticResource Title}" >
      <Label Style="{StaticResource TitleLabel}" Grid.Row="0" Text="{Binding Title}"
           HorizontalOptions="Fill" 
           VerticalOptions="Start"
           
           Padding="10"/>
    </Border>
    <ScrollView Grid.Row="1">
      <VerticalStackLayout Spacing="{OnPlatform WinUI=25}" Padding="{OnPlatform WinUI='30,0',Android='10,0'}">
        <Grid Margin="5" RowDefinitions="Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto,Auto" 
              ColumnDefinitions = "{OnIdiom Phone='3*,1*,4*' ,Default= '3*,1*,3*,2*,2*,2*'}" >
          <!--row 0-->
          <Label Grid.Row="0" Grid.Column="0" Text="{localization:Translate Server}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Label Grid.Row="0" Grid.Column="1" Text="{localization:Translate Url}" VerticalOptions="Center" HorizontalOptions="Start" />
          <controls:TouchEntry Grid.Row="0" Grid.Column="2" Grid.ColumnSpan="2" x:Name="ServerUrlEntry" Margin="2" Keyboard="Text" Text="{Binding ServerUrl}" Placeholder="{localization:Translate Placeholder_Url}" VerticalOptions="Center" HorizontalOptions="Start" ClearButtonVisibility="WhileEditing" />

          <!--row 1-->
          <Label Grid.Row="1" Grid.Column="0" Text="{localization:Translate NfcReader}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Label Grid.Row="1" Grid.Column="1" IsVisible="{OnPlatform WinUI=true, Default=false}" Text="{localization:Translate Type}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Picker Grid.Row="1" Grid.Column="2" IsVisible="{OnPlatform WinUI=true, Default=false}" Margin="2" ItemsSource="{Binding AvailableNfcTypes}" SelectedItem="{Binding NfcReaderType, Mode=TwoWay}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Switch Grid.Row="1" Grid.Column="2" IsVisible="{OnPlatform Android=true, Default=false}" HorizontalOptions="Start" IsToggled="{Binding NfcReaderEnabled}"/>
          <Label Grid.Row="1" Grid.Column="3" IsVisible="{OnPlatform WinUI=true, Default=false}" Text="{localization:Translate Port}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Picker Grid.Row="1" Grid.Column="4"  IsVisible="{OnPlatform WinUI=true, Default=false}" Margin="2" ItemsSource="{Binding AvailablePortNames}" SelectedItem="{Binding NfcReaderSerialPort, Mode=TwoWay}" VerticalOptions="Center"/>
          <Label Grid.Row="1" Grid.Column="5" IsVisible="{OnPlatform WinUI=true, Default=false}" Text="{localization:Translate Inverse}" VerticalOptions="Center" HorizontalOptions="Center" />
          <CheckBox Grid.Row="1" Grid.Column="5" IsVisible="{OnPlatform WinUI=true, Default=false}" IsChecked="{Binding IsNfcReverse, Mode=TwoWay}" HorizontalOptions="End" />
          <Label Grid.Row="1" Grid.Column="2" IsVisible="{OnPlatform Android=true, Default=false}" Text="{localization:Translate Inverse}" HorizontalOptions="End" />
          <CheckBox Grid.Row="1" Grid.Column="2" IsVisible="{OnPlatform Android=true, Default=false}" IsChecked="{Binding IsNfcReverse, Mode=TwoWay}" HorizontalOptions="End" Margin="0,4,0,0" />

          <!--row 2-->
          <Label Grid.Row="2" Grid.Column="0" IsVisible="{OnPlatform WinUI=true, Default=false}" Text="{localization:Translate BarcodeReader}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Label Grid.Row="2" Grid.Column="1" IsVisible="{OnPlatform WinUI=true, Default=false}" Text="{localization:Translate Type}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Picker Grid.Row="2" Grid.Column="2" IsVisible="{OnPlatform WinUI=true, Default=false}" Margin="2" ItemsSource="{Binding AvailableBarcodeReaderTypes}" SelectedItem="{Binding BarcodeReaderType, Mode=TwoWay}" VerticalOptions="Center" />
          <Label Grid.Row="2" Grid.Column="3" IsVisible="{OnPlatform WinUI=true, Default=false}" Text="{localization:Translate Port}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Picker Grid.Row="2" Grid.Column="4" Grid.ColumnSpan="2" IsVisible="{OnPlatform WinUI=true, Default=false}" Margin="2" ItemsSource="{Binding AvailablePortNames}" SelectedItem="{Binding BarcodeReaderSerialPort, Mode=TwoWay}" VerticalOptions="Center"/>

          <!--row 3-->
          <Label Grid.Row="3" Grid.Column="0" IsVisible="{OnPlatform WinUI=true, Android=true, Default=false}" Text="{localization:Translate BluetoothReader}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Label Grid.Row="3" Grid.Column="1" IsVisible="{OnPlatform WinUI=true, Android=true, Default=false}" Text="{localization:Translate Type}" VerticalOptions="Center"  HorizontalOptions="Start" />
          <Entry Grid.Row="3" Grid.Column="2" IsVisible="{OnPlatform WinUI=true, Android=true, Default=false}" IsReadOnly="True" Text="{Binding BluetoothDevicename}" VerticalOptions="Center" HorizontalOptions="Start" />
          <!-- col3+4 on Winui-->
          <Label Grid.Row="3" Grid.Column="3" IsVisible="{OnPlatform WinUI=true, Default=false}" LineBreakMode="TailTruncation" Text="{localization:Translate Address}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Grid Grid.Row="3" Grid.Column="4" Grid.ColumnSpan="2" IsVisible="{OnPlatform WinUI=true, Default=false}" RowDefinitions="Auto" ColumnDefinitions="Auto,Auto">
            <Entry Grid.Column="0" IsReadOnly="True" Text="{Binding BluetoothDeviceAddressString}" VerticalOptions="Center" HorizontalOptions="Start" />
            <ImageButton Grid.Column="1" Command="{Binding SearchBluetoothCommand}" HorizontalOptions="Center" VerticalOptions="Center">
              <ImageButton.Source>
                <FontImageSource FontFamily="MaterialRegular" Glyph="{x:Static m:MaterialRegular.Settings_bluetooth}" Color="{AppThemeBinding Dark=White, Default=Black}" />
              </ImageButton.Source>
            </ImageButton>
          </Grid>

          <!--row 4 only on mobile-->
          <Label Grid.Row="4" Grid.Column="1" IsVisible="{OnPlatform Android=true, Default=false}" LineBreakMode="TailTruncation" Text="{localization:Translate Address}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Grid Grid.Row="4" Grid.Column="2" IsVisible="{OnPlatform Android=true, Default=false}" RowDefinitions="Auto" ColumnDefinitions="Auto,Auto">
            <Entry Grid.Column="0" IsReadOnly="True" Text="{Binding BluetoothDeviceAddressString}" VerticalOptions="Center" HorizontalOptions="Start" />
            <ImageButton Grid.Column="1" Command="{Binding SearchBluetoothCommand}" HorizontalOptions="Center" VerticalOptions="Center">
              <ImageButton.Source>
                <FontImageSource FontFamily="MaterialRegular" Glyph="{x:Static m:MaterialRegular.Settings_bluetooth}" Color="{AppThemeBinding Dark=White, Default=Black}" />
              </ImageButton.Source>
            </ImageButton>
          </Grid>

          <!--row 5-->
          <Label
            Grid.Row="5" Grid.Column="0" Text="{localization:Translate LogonLocale}" VerticalOptions="Center" HorizontalOptions="Start" />
          <controls:TouchEntry Grid.Row="5" Grid.Column="2" Margin="2" x:Name="LogonLocaleEntry" Keyboard="Plain" Text="{Binding LogonLocale}" Placeholder="deAT" VerticalOptions="Center" HorizontalOptions="Start" ClearButtonVisibility="WhileEditing"/>

          <!--row 6-->
          <Label Grid.Row="6" Grid.Column="0" Text="{localization:Translate LogonClient}" VerticalOptions="Center" HorizontalOptions="Start" />
          <controls:TouchEntry Grid.Row="6" Grid.Column="2" Margin="2" x:Name="LogonMandantEntry" Keyboard="Plain" Text="{Binding LogonMandant}" Placeholder="deAT" VerticalOptions="Center" HorizontalOptions="Start" ClearButtonVisibility="WhileEditing" />

          <!--row 7-->
          <Label Grid.Row="7" Grid.Column="0" IsVisible="{OnPlatform WinUI=true,Android=false,iOS=false,MacCatalyst=true}" Text="{localization:Translate Fullscreen}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Switch Grid.Row="7" Grid.Column="2" IsVisible="{OnPlatform WinUI=true, Android=false,iOS=false,MacCatalyst=true}" HorizontalOptions="Start" IsToggled="{Binding IsFullScreen}" />
          <Label Grid.Row="7" Grid.Column="3" IsVisible="{OnPlatform WinUI=true,Android=false,iOS=false,MacCatalyst=true}" Text="{localization:Translate Movable}" VerticalOptions="Center" HorizontalOptions="Start" IsEnabled="{Binding IsFullScreen, Converter={StaticResource InvertedBoolConverter}}"/>
          <Switch Grid.Row="7" Grid.Column="4" IsVisible="{OnPlatform WinUI=true, Android=false, iOS=false,MacCatalyst=true}" HorizontalOptions="Start" IsToggled="{Binding IsSizable}" IsEnabled="{Binding IsFullScreen, Converter={StaticResource InvertedBoolConverter}}"  />

          <!--row 8-->
          <Label Grid.Row="8" Grid.Column="0" IsVisible="{OnPlatform WinUI=true,Android=false, iOS=false,MacCatalyst=true}" Text="{localization:Translate WindowSize}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Label Grid.Row="8" Grid.Column="1" IsVisible="{OnPlatform WinUI=true, Android=false, iOS=false,MacCatalyst=true}" Text="{localization:Translate WidthPx}" VerticalOptions="Center" HorizontalOptions="Start" />
          <controls:NumericEntry Grid.Row="8" Grid.Column="2" Margin="2" x:Name="WindowWidthEntry" IsVisible="{OnPlatform WinUI=true, Android=false, iOS=false,MacCatalyst=true}" IsEnabled="{Binding IsFullScreen, Converter={StaticResource InvertedBoolConverter}}"
            Text="{Binding WindowWidth}" Placeholder="900" MinValue="900" VerticalOptions="Center" HorizontalOptions="Start" />
          <Label Grid.Row="8" Grid.Column="3" IsVisible="{OnPlatform WinUI=true, Android=false, iOS=false,MacCatalyst=true}" Text="{localization:Translate HeightPx}" VerticalOptions="Center" HorizontalOptions="Start" />
          <controls:NumericEntry Grid.Row="8" Grid.Column="4" Margin="2" x:Name="WindowHeightEntry" IsVisible="{OnPlatform WinUI=true, Android=false, iOS=false,MacCatalyst=true}" IsEnabled="{Binding IsFullScreen, Converter={StaticResource InvertedBoolConverter}}"
            Text="{Binding WindowHeight}" Placeholder="600" MinValue="600" VerticalOptions="Center" HorizontalOptions="Start" />

          <!--row 9 Terminal-->
          <Label Grid.Row="9" Grid.Column="0" Text="{localization:Translate CheckInPage}" IsVisible="{Binding IsTerminal}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Switch Grid.Row="9" Grid.Column="2" IsVisible="{Binding IsTerminal}" HorizontalOptions="Start" IsToggled="{Binding CheckInPage}"/>
          <Label Grid.Row="9" Grid.Column="3" Text="{localization:Translate DeviceSerialNumbers}"  IsVisible="{Binding IsTerminal}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Switch Grid.Row="9" Grid.Column="4" HorizontalOptions="Start" IsVisible="{Binding IsTerminal}" IsToggled="{Binding DeviceSerialnumbers}" />
          <!--row 9 App-->
          <Label Grid.Row="9" Grid.Column="0" Grid.ColumnSpan="2" Text="{localization:Translate DeviceSerialNumbers}" IsVisible="{Binding IsTerminal, Converter={StaticResource InvertedBoolConverter}}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Switch Grid.Row="9" Grid.Column="2" HorizontalOptions="Start" IsVisible="{Binding IsTerminal, Converter={StaticResource InvertedBoolConverter}}" IsToggled="{Binding DeviceSerialnumbers}" />

          <!--row 10-->
          <Label Grid.Row="10" Grid.Column="0" Text="{localization:Translate ShowSaldoButton}" IsVisible="{Binding IsTerminal}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Switch Grid.Row="10" Grid.Column="2" IsVisible="{Binding IsTerminal}" HorizontalOptions="Start" IsToggled="{Binding SaldoButton}"/>

          <Label Grid.Row="10" Grid.Column="3" Text="{localization:Translate ShowPieceButton}" IsVisible="{Binding IsTerminal}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Switch Grid.Row="10" Grid.Column="4" IsVisible="{Binding IsTerminal}" HorizontalOptions="Start" IsToggled="{Binding PieceButton}"/>

          <!-- row 11 Terminal-->
          <Grid Grid.Row="11" Grid.Column="0" Grid.ColumnSpan="6" RowDefinitions="Auto,Auto" ColumnDefinitions="3*,1*,3*,2*,2*,2*" IsVisible="{Binding IsTerminal}">
            <Label Grid.Row="0" Grid.Column="0" Text="{localization:Translate ShowRequestsButton}" VerticalOptions="Center" HorizontalOptions="Start" />
            <Switch Grid.Row="0" Grid.Column="2" HorizontalOptions="Start" IsToggled="{Binding RequestsButton}"/>
            <Label Grid.Row="0" Grid.Column="3" Text="{localization:Translate AllowSickRequest}" VerticalOptions="Center" HorizontalOptions="Start" IsVisible="{Binding RequestsButton}" />
            <Switch Grid.Row="0" Grid.Column="4" HorizontalOptions="Start" IsToggled="{Binding AllowSickRequest}" IsVisible="{Binding RequestsButton}"/>
            <Label Grid.Row="1" Grid.Column="0" Text="{localization:Translate ShowMachineButton}" VerticalOptions="Center" HorizontalOptions="Start" />
            <Switch Grid.Row="1" Grid.Column="2" HorizontalOptions="Start" IsToggled="{Binding MachineButton}"/>
          </Grid>
          <!-- row 11 App-->
          <Grid Grid.Row="11" Grid.Column="0" Grid.ColumnSpan="3" RowDefinitions="Auto,Auto" ColumnDefinitions="3*,1*,4*" IsVisible="{Binding IsTerminal, Converter={StaticResource InvertedBoolConverter}}">
            <Label Grid.Row="0" Grid.Column="0" Text="{localization:Translate ShowRequestsButton}"  VerticalOptions="Center" HorizontalOptions="Start" />
            <Switch Grid.Row="0" Grid.Column="2" HorizontalOptions="Start" IsToggled="{Binding RequestsButton}"/>
            <Label Grid.Row="1" Grid.Column="0" Text="{localization:Translate AllowSickRequest}" VerticalOptions="Center" HorizontalOptions="Start" IsVisible="{Binding RequestsButton}" />
            <Switch Grid.Row="1" Grid.Column="2" HorizontalOptions="Start" IsToggled="{Binding AllowSickRequest}" IsVisible="{Binding RequestsButton}"/>
          </Grid>
          
          <!--row 12-->
          <Label Grid.Row="12" Grid.Column="0" Text="{localization:Translate SettingsPassword}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Grid Grid.Row="12" Grid.Column="2" VerticalOptions="Center" HorizontalOptions="Start" ColumnDefinitions="Auto,Auto">
            <controls:TouchEntry Grid.Column="0" Margin="2" x:Name="SettingsPasswordEntry" Keyboard="Numeric" Text="{Binding SettingsPassword}" IsPassword="{Binding IsPasswordHidden}" Placeholder="" ClearButtonVisibility="WhileEditing" />
            <ImageButton Grid.Column="1" Command="{Binding ShowPasswordCommand}" HorizontalOptions="Center" VerticalOptions="Center">
              <ImageButton.Source>
                <FontImageSource FontFamily="MaterialRegular" Glyph="{Binding EyeIconSource}" Color="{AppThemeBinding Dark=White, Default=Black}" />
              </ImageButton.Source>
            </ImageButton>
          </Grid>

          <!--row 13-->
          <Label Grid.Row="13" Grid.Column="0" Text="{localization:Translate IdentifierForDeliveryNote}" IsVisible="{Binding IsTerminal}" VerticalOptions="Center" HorizontalOptions="Start" />
          <controls:TouchEntry Grid.Row="13" Grid.Column="2" Margin="2" x:Name="IdentifierDeliveryNote" Keyboard="Plain" Text="{Binding IdentifierDeliveryNote}" IsVisible="{Binding IsTerminal}" Placeholder="{localization:Translate EmptyForNoNote}"
            VerticalOptions="Center" HorizontalOptions="Start" ClearButtonVisibility="WhileEditing" />

          <!--row 14-->
          <Label Grid.Row="14" Grid.Column="0" Text="{localization:Translate LotDeliveryWithBadAmount}" IsVisible="{Binding IsTerminal}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Switch Grid.Row="14" Grid.Column="2" HorizontalOptions="Start" IsVisible="{Binding IsTerminal}" IsToggled="{Binding BookDeliveryBadAmount}"/>

          <!--row 15-->
          <Label Grid.Row="15" Grid.Column="0" Text="{localization:Translate ItemBarcodeWithoutPrefix}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Switch Grid.Row="15" Grid.Column="2" HorizontalOptions="Start" IsToggled="{Binding ItemBarcodeWithoutPrefix}"/>

          <!--row 16 terminal only-->
          <Label Grid.Row="16" Grid.Column="0" Text="{localization:Translate SortorderCheckInPage}" IsVisible="{Binding IsTerminal}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Picker Grid.Row="16" Grid.Column="2" Margin="2" x:Name="SortorderStaffPicker" ItemsSource="{Binding AvailableSortOrders}" SelectedItem="{Binding CurrentSortOrder, Mode=TwoWay}" IsVisible="{Binding IsTerminal}" VerticalOptions="Center"/>

          <!--row 17-->
          <Label Grid.Row="17" Grid.Column="0" Text="{localization:Translate Language}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Picker Grid.Row="17" Grid.Column="2" Margin="2" x:Name="LocalePicker" ItemsSource="{Binding AvailableLocales}" SelectedItem="{Binding CurrentLocale, Mode=TwoWay}" VerticalOptions="Center"/>

          <!--row 18-->
          <Label Grid.Row="18" Grid.Column="0" Text="{localization:Translate PaperlessProduction}" IsVisible="{Binding IsTerminal}" VerticalOptions="Center" HorizontalOptions="Start" />
          <Switch Grid.Row="18" Grid.Column="2" HorizontalOptions="Start" IsVisible="{Binding IsTerminal}" IsToggled="{Binding IsPaperlessManufacturing}"/>

          <!--row 19-->
          <Border Grid.Row="19" Grid.Column="0" Grid.ColumnSpan="5" Padding="5" IsVisible="{Binding IsPaperlessManufacturing}">
            <Grid Grid.Row="19" Grid.Column="0" Grid.ColumnSpan="4" RowDefinitions="Auto,Auto,Auto,Auto" ColumnDefinitions="Auto,*,Auto" ColumnSpacing="10" RowSpacing="3"  >
              <Label Grid.Row="0" Grid.Column="0" Text="{localization:Translate ManufacturingGroup}" VerticalOptions="Center" HorizontalOptions="Start" />
              <Picker Grid.Row="0" Grid.Column="1" Title="{localization:Translate SelectManufacturingGroup}" ItemsSource="{Binding ProductionGroups}" SelectedItem="{Binding ProductionGroup}" ItemDisplayBinding="{Binding description}"  />
              <ImageButton Grid.Row="0" Grid.Column="2" Command="{Binding ClearCommand}" CommandParameter="0" HorizontalOptions="Center" VerticalOptions="Center">
                <ImageButton.Source>
                  <FontImageSource FontFamily="MaterialRegular" Glyph="{x:Static m:MaterialRegular.Clear}" Color="{AppThemeBinding Dark=White, Default=Black}" />
                </ImageButton.Source>
              </ImageButton>
              <Label Grid.Row="1" Grid.Column="0" Text="{localization:Translate MachineGroup}" VerticalOptions="Center" HorizontalOptions="Start" />
              <Picker Grid.Row="1" Grid.Column="1" Title="{localization:Translate SelectMachineGroup}" ItemsSource="{Binding MachineGroups}" SelectedItem="{Binding MachineGroup}" ItemDisplayBinding="{Binding description}" />
              <ImageButton Grid.Row="1" Grid.Column="2" Command="{Binding ClearCommand}" CommandParameter="1" HorizontalOptions="Center" VerticalOptions="Center">
                <ImageButton.Source>
                  <FontImageSource FontFamily="MaterialRegular" Glyph="{x:Static m:MaterialRegular.Clear}" Color="{AppThemeBinding Dark=White, Default=Black}" />
                </ImageButton.Source>
              </ImageButton>
              <Label Grid.Row="2" Grid.Column="0" Text="{localization:Translate Machine}" VerticalOptions="Center" HorizontalOptions="Start" />
              <Picker Grid.Row="2" Grid.Column="1" Title="{localization:Translate SelectMachine}" ItemsSource="{Binding Machines}" SelectedItem="{Binding Machine}" ItemDisplayBinding="{Binding description}" />
              <ImageButton Grid.Row="2" Grid.Column="2" Command="{Binding ClearCommand}" CommandParameter="2" HorizontalOptions="Center" VerticalOptions="Center">
                <ImageButton.Source>
                  <FontImageSource FontFamily="MaterialRegular" Glyph="{x:Static m:MaterialRegular.Clear}" Color="{AppThemeBinding Dark=White, Default=Black}" />
                </ImageButton.Source>
              </ImageButton>
              <Grid Grid.Row="3" Grid.Column="0" Grid.ColumnSpan="3" RowDefinitions="Auto,Auto" ColumnDefinitions="{OnIdiom Phone='3*,1*,4*' ,Default= '3*,1*,3*,2*,2*'}" >
                <Label Grid.Row="0" Grid.Column="0" Text="{localization:Translate RefreshInterval}" VerticalOptions="Center" HorizontalOptions="Start" />
                <Label Grid.Row="0" Grid.Column="1" Text="{localization:Translate Min0Off}" VerticalOptions="Center" HorizontalOptions="Start" />
                <controls:NumericEntry Grid.Row="0" Grid.Column="2" MinValue="0" MaxValue="60" Placeholder="0 - 60" Text="{Binding RefreshIntervalPaperlessManufacturing}" VerticalOptions="Center" HorizontalOptions="Start" />
                <Label Grid.Row="1" Grid.Column="0" Text="{localization:Translate DaysForPlanning}" VerticalOptions="Center" />
                <controls:NumericEntry Grid.Row="1" Grid.Column="2" MinValue="1" MaxValue="365" Text="{Binding DaysForPlanning}" Placeholder="1 - 365" VerticalOptions="Center" HorizontalOptions="Start" />
                <Label Grid.Row="1" Grid.Column="3" Text="{localization:Translate RequestLimit}" VerticalOptions="Center" />
                <controls:NumericEntry Grid.Row="1" Grid.Column="4" MinValue="200" MaxValue="2000" Text="{Binding PaperlessManufacturingRequestLimit}" Placeholder="200 - 2000"  VerticalOptions="Center" HorizontalOptions="Start" />
              </Grid>
            </Grid>
          </Border>

        </Grid>

        <FlexLayout Margin="5"  Direction="Row" Wrap="Wrap" JustifyContent="{OnIdiom Phone=SpaceBetween, Default=Center}" >
          <Button 
            Text="{localization:Translate Save}" 
            Command="{Binding SaveSettingsCommand}"
            IsEnabled="{Binding IsSaveEnabled}"
            Margin="2,0,0,5"
            HorizontalOptions="Center" VerticalOptions="End" />
          <Button 
            IsVisible="{OnPlatform WinUI=true, Default=false}"
            Text="Export" 
            Command="{Binding ExportCommand}"
            Margin="2,0,0,5"
            HorizontalOptions="Center" VerticalOptions="End" />
          <Button 
            IsVisible="{OnPlatform WinUI=true, Default=false}"
            Text="Import" 
            Command="{Binding ImportCommand}"
            Margin="2,0,0,5"
            HorizontalOptions="Center" VerticalOptions="End" />
          <Button 
            Text="{localization:Translate Close}" 
            Command="{Binding CloseSettingsCommand}"
            Margin="2,0,0,5"
            HorizontalOptions="Center" VerticalOptions="End" />
          <Button 
            Text="{localization:Translate ShowLog}" 
            Command="{Binding ShowLogCommand}"
            Margin="2,0,0,5"
            HorizontalOptions="Center" VerticalOptions="End" />
          <Button
            IsVisible="{OnPlatform WinUI=true, Default=false}"
            Text="{localization:Translate  ExitApplication}"
            Command="{Binding ExitApplicationCommand}"
            Margin="2,0,0,5"
          HorizontalOptions="Center" VerticalOptions="End" />
        </FlexLayout>
        <Label Text="{Binding Version}" HorizontalOptions="Center" />
      </VerticalStackLayout>

    </ScrollView>
    <AbsoluteLayout Grid.Row="1" x:Name="Loading" IsVisible="{Binding IsLoadingCircleVisible}">
      <BoxView Color="Black" Opacity="0.5" AbsoluteLayout.LayoutFlags="All" AbsoluteLayout.LayoutBounds="0, 0, 1, 1" />
      <ActivityIndicator IsRunning="True" Color="White" AbsoluteLayout.LayoutFlags="PositionProportional" 
                                   AbsoluteLayout.LayoutBounds="0.5, 0.5, -1, -1" />
    </AbsoluteLayout>

  </Grid>

</ContentPage>